Subject: Re: linux-next: build failure after merge of the drm-misc tree

From: Maxime Ripard <[email-masked]>
Date: Fri, 5 Nov 2021 12:57:45 +0100

Hi,

On Fri, Nov 05, 2021 at 01:03:43PM +0200, Jani Nikula wrote:
> On Fri, 05 Nov 2021, Stephen Rothwell <[email-masked]> wrote:
> > Hi all,
> >
> > On Mon, 1 Nov 2021 19:42:23 +1100 Stephen Rothwell <[email-masked]> wrote:
> >>
> >> On Fri, 15 Oct 2021 20:26:48 +1100 Stephen Rothwell <[email-masked]> wrote:
> >> >
> >> > After merging the drm-misc tree, today's linux-next build (arm
> >> > multi_v7_defconfig) failed like this:
> >> > 
> >> > drivers/gpu/drm/drm_modeset_lock.c:111:29: error: conflicting types for '__stack_depot_save'
> >> >   111 | static depot_stack_handle_t __stack_depot_save(void)
> >> >       |                             ^~~~~~~~~~~~~~~~~~
> >> > In file included from include/linux/page_ext.h:7,
> >> >                  from include/linux/mm.h:25,
> >> >                  from include/linux/kallsyms.h:13,
> >> >                  from include/linux/bpf.h:20,
> >> >                  from include/linux/bpf-cgroup.h:5,
> >> >                  from include/linux/cgroup-defs.h:22,
> >> >                  from include/linux/cgroup.h:28,
> >> >                  from include/linux/memcontrol.h:13,
> >> >                  from include/linux/swap.h:9,
> >> >                  from include/linux/suspend.h:5,
> >> >                  from include/linux/regulator/consumer.h:35,
> >> >                  from include/linux/i2c.h:18,
> >> >                  from include/drm/drm_crtc.h:28,
> >> >                  from include/drm/drm_atomic.h:31,
> >> >                  from drivers/gpu/drm/drm_modeset_lock.c:24:
> >> > include/linux/stackdepot.h:18:22: note: previous declaration of '__stack_depot_save' was here
> >> >    18 | depot_stack_handle_t __stack_depot_save(unsigned long *entries,
> >> >       |                      ^~~~~~~~~~~~~~~~~~
> >> > 
> >> > Caused by commit
> >> > 
> >> >   cd06ab2fd48f ("drm/locking: add backtrace for locking contended locks without backoff")
> >> > 
> >> > This may only have been revealed because of another fix I have had to
> >> > apply today.
> >> > 
> >> > I have applied the following patch for today.
> >> > 
> >> > From: Stephen Rothwell <[email-masked]>
> >> > Date: Fri, 15 Oct 2021 20:17:52 +1100
> >> > Subject: [PATCH] drm/locking: fix for name conflict
> >> > 
> >> > Fixes: cd06ab2fd48f ("drm/locking: add backtrace for locking contended locks without backoff")
> >> > Signed-off-by: Stephen Rothwell <[email-masked]>
> >> > ---
> >> >  drivers/gpu/drm/drm_modeset_lock.c | 6 +++---
> >> >  1 file changed, 3 insertions(+), 3 deletions(-)
> >> > 
> >> > diff --git a/drivers/gpu/drm/drm_modeset_lock.c b/drivers/gpu/drm/drm_modeset_lock.c
> >> > index 4d32b61fa1fd..ee36dd20900d 100644
> >> > --- a/drivers/gpu/drm/drm_modeset_lock.c
> >> > +++ b/drivers/gpu/drm/drm_modeset_lock.c
> >> > @@ -79,7 +79,7 @@
> >> >  static DEFINE_WW_CLASS(crtc_ww_class);
> >> >  
> >> >  #if IS_ENABLED(CONFIG_DRM_DEBUG_MODESET_LOCK)
> >> > -static noinline depot_stack_handle_t __stack_depot_save(void)
> >> > +static noinline depot_stack_handle_t __drm_stack_depot_save(void)
> >> >  {
> >> >  	unsigned long entries[8];
> >> >  	unsigned int n;
> >> > @@ -108,7 +108,7 @@ static void __stack_depot_print(depot_stack_handle_t stack_depot)
> >> >  	kfree(buf);
> >> >  }
> >> >  #else /* CONFIG_DRM_DEBUG_MODESET_LOCK */
> >> > -static depot_stack_handle_t __stack_depot_save(void)
> >> > +static depot_stack_handle_t __drm_stack_depot_save(void)
> >> >  {
> >> >  	return 0;
> >> >  }
> >> > @@ -317,7 +317,7 @@ static inline int modeset_lock(struct drm_modeset_lock *lock,
> >> >  		ret = 0;
> >> >  	} else if (ret == -EDEADLK) {
> >> >  		ctx->contended = lock;
> >> > -		ctx->stack_depot = __stack_depot_save();
> >> > +		ctx->stack_depot = __drm_stack_depot_save();
> >> >  	}
> >> >  
> >> >  	return ret;
> >> 
> >> This has reappeared today.  I don't know what happened to the drm-misc
> >> tree over the weeked :-(
> >> 
> >> I have reapplied the above fix.
> >
> > So the above drm-misc commit is now in the drm tree, but its fix up
> > commit vanished from the drm-misc tree over the past weekend :-(
> 
> Cc: drm-misc maintainers.
> 
> We normally point drm-misc/for-linux-next at drm-misc-next, *except* to
> drm-misc-next-fixes during the merge window. This is because
> drm-misc-next already starts accumulating stuff that's headed to one
> release later, e.g. currently v5.17. I think that's part of the reason.

Indeed

> I probably should have pushed c4f08d7246a5 ("drm/locking: fix
> __stack_depot_* name conflict") to drm-misc-next-fixes.
> 
> There's still something funny going on, because the drm-misc-next pull
> request [1] isn't part of the drm pull request for v5.16 [2]. Is there
> going to be another drm pull?

The last drm-misc-next PR for some reason didn't got logged into
patchwork, and Dave missed it.

We found out yesterday, and he pulled it today so I assume there will be
a second PR with that last PR and today's drm-misc-next-fixes PR.

Maxime